* ͸
*  PROCEDURE TO BUILD ALLOW A USER TO BUILD A QUERY FROM A PROGRAM.  
* Ĵ
*                                                                    
*  PROCEDURE:   Bld_qry.PRG                                          
*                                                                    
*  DESCRIPTION: Routine to build a query string to be used in        
*               locate or filter for adhoc queries from a            
*               Dbase-IV program.                                    
*                                                                    
*  NOTES:       Expects DBF to be open; returns query string         
*               using the memory variable passed to the procedure.   
*                                                                    
*  SYNTAX:      DO Bld_qry WITH <variable>,"<system name>"           
*                                                                    
*                  variable = return field for query string          
*                             should be blank when calling procedure 
*                  system name = Text name to be displayed on        
*                                query selection screen.             
*                                                                    
*  SAMPLE CODE:    query_string = ""                                 
*                  sys_name =  "PAYROLL SYSTEM"                      
*                                                                    
*                  DO Bld_qry WITH query_string,sys_name             
*                               (or)                                 
*                  DO Bld_qry WITH "","PAYROLL SYSTEM"               
*                                                                    
*                  LOCATE FOR &query_string                          
*                     ......rest.........                            
*                     .......of..........                            
*                     ....program code....                           
*                                                                    
*   RESTRICTIONS:  Will not work for field types of Memo, Undefined  
*                  or Floating Point.                                
*                                                                    
*   Changes made on 1/92:  Display of Field and Type on select.      
*                          Warning message and reslect if invalid    
*                            field type.                             
*                          More documentation added.                 
*                          Colors added to headings.                 
*                          Ability to display System Name on         
*                             screen as passed parameter.            
*    
*  From:         TechNotes dBASE IV, April 1991                      
*  Author:       Don Powells                                         
*  Minor revisions by David Love,                                    
*        additional changes by Alan Frazier (January 1992)           
* ;

PROCEDURE Bld_qry

    PARAMETERS cqrystr,sys_name

    SAVE SCREEN TO qry_scrn
    PRIVATE lc_talk, lc_cursor
    CLEAR
    IF SET("TALK") = "ON"
      SET TALK OFF
      lc_talk = "ON"
        ELSE
          lc_talk = "OFF"
    ENDIF
    lc_cursor = SET("CURSOR")
    SET CURSOR OFF

    DEFINE WINDOW wqrywin FROM 0,0 TO 23,79 NONE
    SET BORDER TO DOUBLE

    DEFINE POPUP pufield FROM 6,1 TO 17,16 ;
      PROMPT STRUCTURE ;
      MESSAGE "Step 1: Select a field name to use with comparision statement."
    ON SELECTION POPUP pufield DEACTIVATE POPUP

    DEFINE POPUP puops FROM 6,23 ;
      MESSAGE "Step 2: Select an operator, and enter value to compare against."
    DEFINE BAR 1 OF puops PROMPT "Equal"
    DEFINE BAR 2 OF puops PROMPT "Not Equal"
    DEFINE BAR 3 OF puops PROMPT "Less Than"
    DEFINE BAR 4 OF puops PROMPT "Less Than or Equal"
    DEFINE BAR 5 OF puops PROMPT "Greater Than"
    DEFINE BAR 6 OF puops PROMPT "Greater Than or Equal  "
    ON SELECTION POPUP puops DEACTIVATE POPUP

    DEFINE POPUP pucon FROM 15,23 TO 19,45 ;
      MESSAGE "Step 3: Select desired connector or choose DONE"
    DEFINE BAR 1 OF pucon PROMPT "DONE"
    DEFINE BAR 2 OF pucon PROMPT "AND"
    DEFINE BAR 3 OF pucon PROMPT "OR"
    ON SELECTION POPUP pucon DEACTIVATE POPUP

    DEFINE WINDOW wdata FROM 10,0 TO 12,79 DOUBLE
    ACTIVATE WINDOW wqrywin


    SET COLOR OF NORMAL TO G+/B
    head_name = "BUILD QUERY EXPRESSION FOR " + TRIM(sys_name)
    DO Saycenter WITH 2,80,head_name
    SET COLOR OF NORMAL TO G/B
    DO Saycenter WITH 3,80,"(Press Escape at any time to Abort)"
    SET COLOR OF NORMAL TO GB+/B
    @ 5,1 SAY "Field Names"
    @ 5,23 SAY "Operators"
    @ 14,23 SAY "Connectors"
    @ 5,50 SAY "Data Base Name"
    @ 6,50 TO 6,64
    @ 14,50 SAY "Selected Field and Type"
    @ 15,50 TO 15,73
    SET COLOR OF NORMAL TO W+/B
    @ 7,50 SAY UPPER(DBF())
    SHOW POPUP pufield
    SHOW POPUP puops
    SHOW POPUP pucon
    SET COLOR OF NORMAL TO GB+/B
    @ 21,0 to 21,79
    DO Saycenter WITH 21,80,"<Expression>"
    SET COLOR OF NORMAL TO W+/B

    cqrystr = ""
    kESC = 27
    nfldbar = 0
    nopsbar = 0
    nconbar = 0
    DECLARE opsary[6]
    opsary[1] = "="
    opsary[2] = "<>"
    opsary[3] = "<"
    opsary[4] = "<="
    opsary[5] = ">"
    opsary[6] = ">="

    DO WHILE .T.
      ACTIVATE POPUP pufield
      nfldbar = BAR()
      ccurfld = PROMPT()
      ccurtype = TYPE(ccurfld)
      IF LASTKEY() = 27
        EXIT
        ENDIF
      @ 22,0 SAY cqrystr
      @ 17,50 clear to 17,79
      @ 16,50 clear to 16,79
    DO CASE
        CASE ccurtype = "C"
           @ 16,50 SAY TRIM(ccurfld) + " = Character"
        CASE ccurtype = "N"
           @ 16,50 SAY TRIM(ccurfld) + " = Numeric"
        CASE ccurtype = "D"
           @ 16,50 SAY TRIM(ccurfld) + " = Date"
        CASE ccurtype = "L"
           @ 16,50 SAY TRIM(ccurfld) + " = Logical"
        CASE ccurtype = "F"
           @ 16,50 SAY TRIM(ccurfld) + " = Fltg. Point"
        CASE ccurtype = "M"
           @ 16,50 SAY TRIM(ccurfld) + " = Memo"
        CASE ccurtype = "U"
           @ 16,50 SAY TRIM(ccurfld) + " = Undefined"
        OTHERWISE
           @ 16,50 SAY TRIM(ccurfld) + " = Other"
      ENDCASE
      IF ccurtype = "M" .OR. ccurtype = "F" .OR. ccurtype = "U";
                        .OR. ccurtype = " "
           DO Warnbeep
           SET COLOR OF NORMAL TO R+/B
           @ 17,50 SAY "Cannot use this Type, Reselect"
           SET COLOR OF NORMAL TO W+/B
           LOOP
           ENDIF
      IF LASTKEY() = 27
        EXIT
          ELSE
            cqrystr = cqrystr + IIF("" = cqrystr,""," ") + ccurfld
      ENDIF

      DO WHILE .T.
        ACTIVATE POPUP puops
        nopsbar = BAR()
        coperator = IIF(nopsbar = 0,"",opsary[nopsbar])
        IF LASTKEY() = kESC
          EXIT
            ELSE
              IF ccurtype = "L" .AND. nopsbar <> 1 .AND. nopsbar <> 2
                DO Warnbeep
                LOOP
                  ELSE
                    cqrystr = cqrystr + " " + coperator
                    EXIT
              ENDIF
        ENDIF
      ENDDO
      IF LASTKEY() = kESC
        EXIT
      ENDIF
      @ 22,0 say cqrystr

      DO CASE
        CASE ccurtype = "C"
          getvar = SPACE(LEN(&ccurfld))
        CASE ccurtype = "N"
          getvar = 0.00
        CASE ccurtype = "D"
          getvar = DATE()
        CASE ccurtype = "L"
          getvar = .T.
        OTHERWISE
          getvar = ""
      ENDCASE

      ACTIVATE WINDOW wdata
      @ 0,1 SAY "Enter "+TRIM(ccurfld)+":" ;
        GET getvar ;
        PICTURE get_pic(ccurfld)
      SET CURSOR ON
      READ
      SET CURSOR OFF
      DEACTIVATE WINDOW wdata
      IF LASTKEY() = kESC
        EXIT
          ELSE
            DO CASE
              CASE ccurtype = "C"
                cqrystr=cqrystr+" '"+TRIM(getvar)+"'"
              CASE ccurtype = "N"
                cqrystr=cqrystr+" "+LTRIM(STR(getvar))
              CASE ccurtype = "L"
                cqrystr=cqrystr+" "+IIF(getvar,".T.",".F.")
              CASE ccurtype = "D"
                cqrystr=cqrystr+" CTOD('"+DTOC(getvar)+"')"
            ENDCASE
            @ 22,0 SAY cqrystr
      ENDIF
      @ 16,50 clear to 16,79

      ACTIVATE POPUP pucon
      nconbar = BAR()
      ccuron = PROMPT()

      DO CASE
        CASE LASTKEY() = kESC
          EXIT
        CASE ccuron = "AND"
          ccuron = ".AND."
        CASE ccuron = "OR"
          ccuron = ".OR."
        CASE ccuron = "DONE"
          EXIT
      ENDCASE
      cqrystr = cqrystr+" "+ccuron
      @ 22,1 SAY cqrystr
    ENDDO
    IF LASTKEY() = kESC
      cqrystr = ""
    ENDIF
    DEACTIVATE WINDOW wqrywin
    RESTORE SCREEN FROM qry_scrn
    RELEASE SCREEN qry_scrn
    RELEASE WINDOWS wqrywin,wdata
    RELEASE POPUPS pufield,puops,pucon
    SET CURSOR &lc_cursor
    SET TALK &lc_talk
    RETURN
    * 
    FUNCTION get_pic
      PARAMETERS cfield
      PRIVATE cretval, cstring
      cstring = SPACE(20)
      DO CASE
        CASE TYPE(cfield) = "C"
          cretval = "@S"+LTRIM(STR(MIN(LEN(&cfield),59)))
        CASE TYPE(cfield) = "N"
          cretval = STR(&cfield)
          IF "." $ cstring
            cretval = REPLICATE("9",AT(".",cstring) - 1) + "."
            cretval = cretval + REPLICATE("9",;
              LEN(cstring) - LEN(cstring))
              ELSE
                cretval = REPLICATE("9",LEN(cstring))
          ENDIF
        OTHERWISE
          cretval = ""
      ENDCASE
    RETURN (cretval)
    * 
    PROCEDURE Saycenter
      PARAMETERS nrow, ndispwidth, cstring
      ncol = (ndispwidth - LEN(cstring)) / 2
      ncol = IIF(ncol<0,0,ncol)
      @ nrow,ncol SAY cstring
    RETURN
    * 
    PROCEDURE Tone
      PARAMETERS freq, dura
      SET BELL TO freq, dura
      ?? CHR(7)
    RETURN
    * 
    PROCEDURE Warnbeep
      mfreq = 300
      mdura = 3
      mfreq2 = 50
      mdura2 = 4.5
      DO Tone WITH mfreq, mdura
      DO Tone WITH mfreq2, mdura2
    RETURN
    * 

* Ŀ
*   END OF PROCEDURE BLD_QRY                             
* 


